Index: issm/trunk/src/jl/core/friction.jl
===================================================================
--- issm/trunk/src/jl/core/friction.jl	(revision 26744)
+++ issm/trunk/src/jl/core/friction.jl	(revision 26744)
@@ -0,0 +1,43 @@
+#Friction class definition
+
+abstract type CoreFriction end
+struct CoreBuddFriction#{{{
+	H_input::ElementInput
+	b_input::ElementInput
+	c_input::ElementInput
+	rho_ice::Float64
+	rho_water::Float64
+	g::Float64
+end# }}}
+function CoreFriction(element::Tria) #{{{
+
+	frictionlaw = FindParam(element, FrictionLawEnum)
+
+	if frictionlaw==1
+		H_input  = GetInput(element, ThicknessEnum)
+		b_input  = GetInput(element, BaseEnum)
+		c_input  = GetInput(element, FrictionCoefficientEnum)
+
+		rho_ice   = FindParam(element, MaterialsRhoIceEnum)
+		rho_water = FindParam(element, MaterialsRhoSeawaterEnum)
+		g         = FindParam(element, ConstantsGEnum)
+
+		return CoreBuddFriction(H_input, b_input, c_input, rho_ice, rho_water, g)
+	else
+		error("Friction ",typeof(md.friction)," not supported yet")
+	end
+end#}}}
+
+#vertices functions
+function Alpha2(friction::CoreBuddFriction, gauss::GaussTria, i::Int64) #{{{
+
+	#Get effective pressure
+	H = GetInputValue(friction.H_input, gauss, i)
+	b = GetInputValue(friction.b_input, gauss, i)
+	c = GetInputValue(friction.c_input, gauss, i)
+	N = friction.rho_ice*friction.g*H + friction.rho_water*friction.g*b
+
+	if(N<0) N=0 end
+
+	return c^2*N
+end #}}}
Index: issm/trunk/src/jl/core/gauss.jl
===================================================================
--- issm/trunk/src/jl/core/gauss.jl	(revision 26744)
+++ issm/trunk/src/jl/core/gauss.jl	(revision 26744)
@@ -0,0 +1,113 @@
+#Gauss class definition
+struct GaussTria #{{{
+	numgauss::Int64
+	weights::Vector{Float64}
+	coords1::Vector{Float64}
+	coords2::Vector{Float64}
+	coords3::Vector{Float64}
+end #}}}
+function Base.show(io::IO, this::GaussTria)# {{{
+
+	println(io,"GaussTria:")
+	println(io,"   numgauss: ",this.numgauss)
+	println(io,"   weights:  ",this.weights)
+	println(io,"   coords1:  ",this.coords1)
+	println(io,"   coords2:  ",this.coords2)
+	println(io,"   coords3:  ",this.coords3)
+end# }}}
+
+#Gauss constructor
+function GaussTria(order::Int64) #{{{
+
+	#=Gauss quadrature points for the triangle.
+	Higher-order points from D.A. Dunavant, "High Degree Efficient
+	Symmetrical Gaussian Quadrature Rules for the Triangle", IJNME,
+	Vol. 21, pp. 1129-1148 (1985), as transcribed for Probe rules3.=#
+
+	if(order==1)
+		npoints = 1
+		weights = [1.732050807568877]
+		coords1 = [0.333333333333333]
+		coords2 = [0.333333333333333]
+		coords3 = [0.333333333333333]
+	elseif(order==2)
+		npoints = 3
+		weights = [0.577350269189625; 0.577350269189625; 0.577350269189625]
+		coords1 = [0.666666666666667; 0.166666666666667; 0.166666666666667]
+		coords2 = [0.166666666666667; 0.666666666666667; 0.166666666666667]
+		coords3 = [0.166666666666667; 0.166666666666667; 0.666666666666667]
+	elseif(order==3)
+		npoints = 4
+		weights = [-0.974278579257493; 0.902109795608790; 0.902109795608790; 0.902109795608790]
+		coords1 = [ 0.333333333333333; 0.600000000000000; 0.200000000000000; 0.200000000000000]
+		coords2 = [ 0.333333333333333; 0.200000000000000; 0.600000000000000; 0.200000000000000]
+		coords3 = [ 0.333333333333333; 0.200000000000000; 0.200000000000000; 0.600000000000000]
+	else
+		error("order ",order," not supported yet");
+	end
+
+	return GaussTria(npoints,weights,coords1,coords2,coords3)
+end# }}}
+function GaussTria(finiteelement::IssmEnum) #{{{
+
+	if(finiteelement==P0Enum)
+		npoints = 1
+		weights = [1.]
+		coords1 = [0.333333333333333]
+		coords2 = [0.333333333333333]
+		coords3 = [0.333333333333333]
+	elseif(finiteelement==P1Enum)
+			npoints = 3
+			weights = 0.333333333333333*ones(3)
+			coords1 = [1.; 0.; 0.]
+			coords2 = [0.; 1.; 0.]
+			coords3 = [0.; 0.; 1.]
+	else
+		error("finite element ", finiteelement," not supported yet");
+	end
+
+	return GaussTria(npoints,weights,coords1,coords2,coords3)
+end# }}}
+function GaussTria(area_coordinates::Matrix{Float64}, order::Int64) #{{{
+	#=Gauss-Legendre quadrature points.
+
+	The recurrence coefficients for Legendre polynomials on (-1,1)
+	are defined (from the ORTHPOL subroutine RECUR with ipoly=1) as:
+
+	alpha(i)=0.
+	beta (i)=1./(4.-1./(i-1)^2))
+
+	For degree p, the required number of Gauss-Legendre points is
+	n>=(p+1)/2.=#
+
+	if(order==1)
+		npoint  = 1
+		weights = [2.000000000000000]
+		coords  = [0.000000000000000]
+	elseif(order==2)
+		npoints = 2
+		weights = [1.000000000000000, 1.000000000000000]
+		coords  = [-0.577350269189626, 0.577350269189626]
+	elseif(order==3)
+		npoints = 3
+		weights = [0.555555555555556, 0.888888888888889, 0.555555555555556]
+		coords  = [-0.774596669241483, 0.000000000000000, 0.774596669241483]
+	elseif(order==4)
+		npoints = 4
+		weights = [0.347854845137454, 0.652145154862546, 0.652145154862546, 0.347854845137454]
+		coords  = [-0.861136311594053,-0.339981043584856, 0.339981043584856, 0.861136311594053]
+	else
+      error("order ",order," not supported yet");
+	end
+
+   coords1  = Vector{Float64}(undef,npoints)
+   coords2  = Vector{Float64}(undef,npoints)
+   coords3  = Vector{Float64}(undef,npoints)
+   for i in 1:npoints
+      coords1[i]  = 0.5*(area_coordinates[1,1]+area_coordinates[2,1]) + 0.5*coords[i]*(area_coordinates[2,1]-area_coordinates[1,1]);
+      coords2[i]  = 0.5*(area_coordinates[1,2]+area_coordinates[2,2]) + 0.5*coords[i]*(area_coordinates[2,2]-area_coordinates[1,2]);
+      coords3[i]  = 0.5*(area_coordinates[1,3]+area_coordinates[2,3]) + 0.5*coords[i]*(area_coordinates[2,3]-area_coordinates[1,3]);
+   end
+
+	return GaussTria(npoints, weights, coords1, coords2, coords3)
+end# }}}
Index: issm/trunk/src/jl/core/inputs.jl
===================================================================
--- issm/trunk/src/jl/core/inputs.jl	(revision 26744)
+++ issm/trunk/src/jl/core/inputs.jl	(revision 26744)
@@ -0,0 +1,167 @@
+#Input class definition
+abstract type Input end
+struct BoolInput <: Input#{{{
+	enum::IssmEnum
+	values::Matrix{Bool}
+end# }}}
+struct IntInput <: Input#{{{
+	enum::IssmEnum
+	values::Matrix{Int64}
+end# }}}
+struct ElementInput <: Input#{{{
+	enum::IssmEnum
+	interp::IssmEnum
+	values::Vector{Float64}
+	element_values::Vector{Float64}
+end# }}}
+
+#Inputs dataset definition
+mutable struct Inputs #{{{
+	numberofelements::Int64
+	numberofvertices::Int64
+	lookup::Dict{IssmEnum,Input}
+end# }}}
+
+#Inputs functions
+function GetInput(inputs::Inputs,enum::IssmEnum) #{{{
+
+	#Does this input exist
+	if !haskey(inputs.lookup,enum)
+		error("Input ",enum," not found")
+	end
+
+	#return input
+	return inputs.lookup[enum]
+
+end#}}}
+function SetInput(inputs::Inputs,enum::IssmEnum,index::Int64,value::Bool) #{{{
+
+	#Does this input exist
+	if !haskey(inputs.lookup,enum)
+		#it does not exist yet, we need to create it...
+		@assert inputs.numberofelements > 0
+		input = BoolInput(enum,zeros(Bool,inputs.numberofelements))
+		inputs.lookup[enum] = BoolInput(enum,zeros(Bool,inputs.numberofelements))
+	end
+
+	#Get this input and check type
+	input = inputs.lookup[enum]
+	if typeof(input)!=BoolInput error("not consistent") end
+
+	#set value
+	@assert index>0 && index<=inputs.numberofelements
+	input.values[index] = value
+end#}}}
+function SetTriaInput(inputs::Inputs,enum::IssmEnum,interp::IssmEnum,index::Int64,value::Float64) #{{{
+
+	#Does this input exist
+	if !haskey(inputs.lookup,enum)
+		#it does not exist yet, we need to create it...
+		@assert inputs.numberofelements > 0
+		if interp==P0Enum
+			inputs.lookup[enum] = ElementInput(enum,interp,zeros(inputs.numberofelements),Vector{Float64}(undef,1))
+		elseif interp==P1Enum
+			inputs.lookup[enum] = ElementInput(enum,interp,zeros(inputs.numberofvertices),Vector{Float64}(undef,3))
+		else
+			error("not supported yet")
+		end
+	end
+
+	#Get this input and check type
+	input = inputs.lookup[enum]
+	if typeof(input)!=ElementInput error("input type not consistent") end
+	if interp!=input.interp        error("input interpolations not consistent") end
+
+	#set value
+	input.values[index] = value
+end#}}}
+function SetTriaInput(inputs::Inputs,enum::IssmEnum,interp::IssmEnum,indices::Vector{Int64},values::Vector{Float64}) #{{{
+
+	#Does this input exist
+	if !haskey(inputs.lookup,enum)
+		#it does not exist yet, we need to create it...
+		@assert inputs.numberofvertices>0
+		if interp==P1Enum
+			inputs.lookup[enum] = ElementInput(enum,interp,zeros(inputs.numberofvertices),Vector{Float64}(undef,3))
+		else
+			error("not supported yet")
+		end
+	end
+
+	#Get this input and check type
+	input = inputs.lookup[enum]
+	if typeof(input)!=ElementInput error("input type not consistent") end
+	if interp!=input.interp        error("input interpolations not consistent") end
+
+	#set value
+	input.values[indices] = values
+end#}}}
+function GetInputAverageValue(input::ElementInput) #{{{
+
+	numnodes = NumberofNodesTria(input.interp)
+	value = 0.0
+
+	for i in 1:numnodes
+		value+=input.element_values[i]
+	end
+
+	return value/numnodes
+
+end#}}}
+function GetInputMin(input::ElementInput) #{{{
+
+	return minimum(input.element_values)
+
+end#}}}
+function GetInputValue(input::ElementInput,gauss::GaussTria,i::Int64) #{{{
+
+	if input.interp==P0Enum
+		return input.element_values[1]
+	elseif input.interp==P1Enum
+		value = input.element_values[1]*gauss.coords1[i] +  input.element_values[2]*gauss.coords2[i] +  input.element_values[3]*gauss.coords3[i]
+	else
+		error("not implemented yet")
+	end
+
+	return value
+
+end#}}}
+function GetInputDerivativeValue(input::ElementInput,xyz_list::Matrix{Float64},gauss::GaussTria,i::Int64) #{{{
+
+	#Get nodal function derivatives in reference element
+	numnodes = NumberofNodesTria(input.interp)
+	dbasis_ref = Matrix{Float64}(undef,numnodes,2)
+	NodalFunctionsDerivativesReferenceTria(dbasis_ref,gauss,input.interp)
+
+	#Get invert of the Jacobian
+	Jinv = JacobianInvert(xyz_list,gauss)
+
+	#Build dbasis:
+	#[ dNi/dx ] = Jinv * [dNhat_i/dr]
+	#[ dNi/dy ] =        [dNhat_i/ds]
+	dbasis = Matrix{Float64}(undef,numnodes,2)
+	for i in 1:3
+		dbasis[i,1] = Jinv[1,1]*dbasis_ref[i,1]+Jinv[1,2]*dbasis_ref[i,2]
+		dbasis[i,2] = Jinv[2,1]*dbasis_ref[i,1]+Jinv[2,2]*dbasis_ref[i,2]
+	end
+
+	#Get derivatives: dp/dx dp/dy
+	dp = [0.0;0.0]
+	for i in 1:3
+		dp[1] += dbasis[i,1]*input.element_values[i]
+		dp[2] += dbasis[i,2]*input.element_values[i]
+	end
+
+	return dp
+
+end#}}}
+function DuplicateInput(inputs::Inputs, old::IssmEnum, new::IssmEnum)#{{{
+
+	#Fetch input that needs to be copied
+	oldinput = inputs.lookup[old]
+
+	if typeof(oldinput)==ElementInput
+		inputs.lookup[new] = ElementInput(new, oldinput.interp, copy(oldinput.values), copy(oldinput.element_values))
+	end
+
+end#}}}
Index: issm/trunk/src/jl/core/matice.jl
===================================================================
--- issm/trunk/src/jl/core/matice.jl	(revision 26744)
+++ issm/trunk/src/jl/core/matice.jl	(revision 26744)
@@ -0,0 +1,44 @@
+#Matice class definition
+struct Matice#{{{
+	vx_input::ElementInput
+	vy_input::ElementInput
+	B_input::ElementInput
+	n_input::ElementInput
+end# }}}
+
+function Matice(element::Tria) #{{{
+
+	vx_input  = GetInput(element, VxEnum)
+	vy_input  = GetInput(element, VyEnum)
+	B_input   = GetInput(element, MaterialsRheologyBEnum)
+	n_input   = GetInput(element, MaterialsRheologyNEnum)
+
+	return Matice(vx_input, vy_input, B_input, n_input)
+end#}}}
+
+#vertices functions
+function ViscositySSA(matice::Matice, xyz_list::Matrix{Float64}, gauss::GaussTria, i::Int64) #{{{
+
+	#Get strain rate
+	dvx = GetInputDerivativeValue(matice.vx_input,xyz_list,gauss,i)
+	dvy = GetInputDerivativeValue(matice.vy_input,xyz_list,gauss,i)
+	eps_xx = dvx[1]
+	eps_yy = dvy[2]
+	eps_xy = 0.5*(dvx[2] + dvy[1])
+
+	#In SSA, eps_eff^2 = exx^2 + eyy^2 + exy^2 + exx*eyy
+	eps_eff = sqrt(eps_xx*eps_xx + eps_yy*eps_yy + eps_xy*eps_xy + eps_xx*eps_yy)
+
+	#Get B and n
+	n = GetInputValue(matice.n_input, gauss, i)
+	B = GetInputValue(matice.B_input, gauss, i)
+
+	#Compute viscosity
+	if eps_eff==0.
+		mu = 1.e+14/2
+	else
+		mu = B/(2*eps_eff^((n-1)/n))
+	end
+
+	return mu
+end #}}}
Index: issm/trunk/src/jl/core/modules.jl
===================================================================
--- issm/trunk/src/jl/core/modules.jl	(revision 26744)
+++ issm/trunk/src/jl/core/modules.jl	(revision 26744)
@@ -0,0 +1,388 @@
+#Model Processor and Core I/O
+function FetchDataToInput(md::model,inputs::Inputs,elements::Vector{Tria},data::Vector{Float64},enum::IssmEnum) #{{{
+	for i in 1:length(elements)
+		InputCreate(elements[i],inputs,data,enum)
+	end
+end#}}}
+function ModelProcessor(md::model, solutionstring::String) #{{{
+
+	#Initialize structures
+	elements    = Vector{Tria}(undef,0)
+	vertices    = Vector{Vertex}(undef,0)
+	results     = Vector{Result}(undef,0)
+	parameters  = Parameters(Dict{IssmEnum,Parameter}())
+	inputs      = Inputs(md.mesh.numberofelements, md.mesh.numberofvertices, Dict{IssmEnum,Input}())
+
+	#Create  elements, vertices and materials (independent of the analysis)
+	CreateElements(elements, md)
+	CreateVertices(vertices, md)
+	CreateParameters(parameters, md)
+	CreateInputs(inputs,elements, md)
+	if solutionstring=="TransientSolution"
+		UpdateParameters(TransientAnalysis(), parameters, md)
+	end
+
+	#Now create analysis specific data structure
+	if solutionstring=="StressbalanceSolution"
+		analyses = [StressbalanceAnalysis()]
+	elseif solutionstring=="TransientSolution"
+		analyses = [StressbalanceAnalysis(), MasstransportAnalysis()]
+	else
+		error(solutionstring, " not supported by ModelProcessor")
+	end
+
+	#Initialize analysis specific datasets
+	numanalyses = length(analyses)
+	nodes       = Vector{Vector{Node}}(undef,numanalyses)
+	constraints = Vector{Vector{Constraint}}(undef,numanalyses)
+	for i in 1:numanalyses
+		analysis = analyses[i]
+		println("   creating datasets for analysis ", typeof(analysis))
+		nodes[i]       = Vector{Node}(undef,0)
+		constraints[i] = Vector{Constraint}(undef,0)
+
+		UpdateParameters(analysis, parameters, md)
+		UpdateElements(analysis, elements, inputs, md)
+		CreateNodes(analysis, nodes[i], md)
+		CreateConstraints(analysis, constraints[i], md)
+
+		#Configure objects
+		ConfigureObjectx(elements, nodes[i], vertices, parameters, inputs, i)
+	end
+
+	#Build FemModel
+	femmodel = FemModel(analyses, elements, vertices,
+							  Vector{Node}(undef,0), nodes,
+							  parameters, inputs,
+							  Vector{Constraint}(undef,0), constraints,
+							  results)
+
+	println("      detecting active vertices")
+	GetMaskOfIceVerticesLSMx0(femmodel)
+
+	return femmodel
+
+end# }}}
+function CreateElements(elements::Vector{Tria},md::model) #{{{
+
+	#Make sure elements is currently empty
+	@assert length(elements)==0
+
+
+
+	count = 0
+	for i in 1:md.mesh.numberofelements
+
+		#Assume Linear Elements for now
+		vertexids = md.mesh.elements[i,:]
+		nodeids   = md.mesh.elements[i,:]
+
+		#Call constructor and add to dataset elements
+		push!(elements,Tria(i,count, vertexids))
+	end
+
+end# }}}
+function CreateVertices(vertices::Vector{Vertex},md::model) #{{{
+
+	#Make sure vertices is currently empty
+	@assert length(vertices)==0
+
+	#Get data from md
+	x = md.mesh.x
+	y = md.mesh.y
+
+	count = 0
+	for i in 1:md.mesh.numberofvertices
+		push!(vertices,Vertex(i,x[i],y[i],0.))
+	end
+
+end# }}}
+function CreateParameters(parameters::Parameters,md::model) #{{{
+
+	#Get data from md
+	AddParam(parameters,md.materials.rho_ice,MaterialsRhoIceEnum)
+	AddParam(parameters,md.materials.rho_water,MaterialsRhoSeawaterEnum)
+	AddParam(parameters,md.materials.rho_freshwater,MaterialsRhoFreshwaterEnum)
+	AddParam(parameters,md.constants.g,ConstantsGEnum)
+	
+	#Set step and time, this will be overwritten if we run a transient
+	AddParam(parameters,1,StepEnum)
+	AddParam(parameters,0.0,TimeEnum)
+
+end# }}}
+function CreateInputs(inputs::Inputs,elements::Vector{Tria},md::model) #{{{
+
+	#Only assume we have Matice for now
+	FetchDataToInput(md,inputs,elements,md.materials.rheology_B,MaterialsRheologyBEnum)
+	FetchDataToInput(md,inputs,elements,md.materials.rheology_n,MaterialsRheologyNEnum)
+end# }}}
+function OutputResultsx(femmodel::FemModel, md::model, solution::String)# {{{
+
+
+	if solution=="TransientSolution"
+
+		#Compute maximum number of steps
+		maxstep = 0
+		for i in length(femmodel.results)
+			if(femmodel.results[i].step>maxstep) maxstep = femmodel.results[i].step end
+		end
+
+		#Initialize vector now that we know the size
+		output = Vector{Dict}(undef, maxstep)
+		for i in 1:maxstep; output[i] = Dict() end
+
+		#Insert results in vector
+		for i in 1:length(femmodel.results)
+			result = femmodel.results[i]
+			step   = femmodel.results[i].step
+			(output[step])[EnumToString(result.enum)] = result.value
+		end
+	else
+		output = Dict()
+		for i in length(femmodel.results)
+			result = femmodel.results[i]
+			output[EnumToString(result.enum)] = result.value
+		end
+	end
+
+	md.results[solution] = output
+
+end# }}}
+
+#Other modules
+function ConfigureObjectx(elements::Vector{Tria}, nodes::Vector{Node}, vertices::Vector{Vertex}, parameters::Parameters, inputs::Inputs, analysis::Int64) #{{{
+
+	for i in 1:length(elements)
+		Configure(elements[i], nodes, vertices, parameters, inputs, analysis)
+	end
+
+end# }}}
+function SpcNodesx(nodes::Vector{Node},constraints::Vector{Constraint},parameters::Parameters) #{{{
+
+	for i in 1:length(constraints)
+		ConstrainNode(constraints[i],nodes,parameters)
+	end
+
+end# }}}
+function NodesDofx(nodes::Vector{Node}, parameters::Parameters) #{{{
+
+	#Do we have any nodes?
+	if length(nodes)==0
+		return
+	end
+
+	#Do we really need to update dof indexing
+	if(~RequiresDofReindexing(nodes)) return end
+
+	print("   Renumbering degrees of freedom\n")
+	DistributeDofs(nodes,GsetEnum)
+	DistributeDofs(nodes,FsetEnum)
+	DistributeDofs(nodes,SsetEnum)
+
+end# }}}
+function GetSolutionFromInputsx(analysis::Analysis,femmodel::FemModel) #{{{
+
+	#Get size of vector
+	gsize = NumberOfDofs(femmodel.nodes,GsetEnum)
+
+	#Initialize solution vector
+	ug = IssmVector(gsize)
+
+	#Go through elements and plug in solution
+	for i=1:length(femmodel.elements)
+		GetSolutionFromInputs(analysis,ug,femmodel.elements[i])
+	end
+
+	return ug
+
+end#}}}
+function InputUpdateFromSolutionx(analysis::Analysis,ug::IssmVector,femmodel::FemModel) #{{{
+
+	#Go through elements and plug in solution
+	for i=1:length(femmodel.elements)
+		InputUpdateFromSolution(analysis,ug.vector,femmodel.elements[i])
+	end
+
+	return ug
+
+end#}}}
+function InputUpdateFromVectorx(femmodel::FemModel, vector::Vector{Float64}, enum::IssmEnum, layout::IssmEnum)
+
+	#Go through elements and plug in solution
+	for i=1:length(femmodel.elements)
+		InputUpdateFromVector(femmodel.elements[i], vector, enum, layout)
+	end
+
+end#}}}
+function InputDuplicatex(femmodel::FemModel, oldenum::IssmEnum, newenum::IssmEnum) #{{{
+	DuplicateInput(femmodel.inputs, oldenum, newenum)
+end#}}}
+function Reducevectorgtofx(ug::IssmVector,nodes::Vector{Node}) #{{{
+
+	#Get size of output vector
+	fsize = NumberOfDofs(nodes,FsetEnum)
+
+	#Initialize output vector
+	uf = IssmVector(fsize)
+
+	#Go through elements and plug in solution
+	for i=1:length(nodes)
+		VecReduce(nodes[i],ug.vector,uf)
+	end
+
+	return uf
+
+end#}}}
+function Mergesolutionfromftogx(ug::IssmVector, uf::IssmVector, ys::IssmVector, nodes::Vector{Node}) #{{{
+
+	#Go through elements and plug in solution
+	for i=1:length(nodes)
+		VecMerge(nodes[i],ug,uf.vector,ys.vector)
+	end
+
+	return ug
+
+end#}}}
+function Reduceloadx!(pf::IssmVector, Kfs::IssmMatrix, ys::IssmVector) #{{{
+
+	#Is there anything to do?
+	m, n = GetSize(Kfs)
+
+	if(m*n>0)
+
+		#Allocate Kfs*ys
+		Kfsy_s=IssmVector(m)
+
+		#Perform multiplication
+		MatMult!(Kfs,ys,Kfsy_s)
+
+		#Subtract Kfs*ys from pf
+		AXPY!(pf,-1.0,Kfsy_s)
+
+	end
+end#}}}
+function SystemMatricesx(femmodel::FemModel,analysis::Analysis)# {{{
+
+	#Allocate matrices
+	fsize = NumberOfDofs(femmodel.nodes,FsetEnum)
+	ssize = NumberOfDofs(femmodel.nodes,SsetEnum)
+	Kff = IssmMatrix(fsize,fsize)
+	Kfs = IssmMatrix(fsize,ssize)
+	pf  = IssmVector(fsize)
+
+	#Construct Stiffness matrix and load vector from elements
+	for i in 1:length(femmodel.elements)
+		Ke = CreateKMatrix(analysis,femmodel.elements[i])
+		pe = CreatePVector(analysis,femmodel.elements[i])
+
+		if(!isnothing(Ke)) AddToGlobal!(Ke,Kff,Kfs) end
+		if(!isnothing(pe)) AddToGlobal!(pe,pf) end
+	end
+
+	Assemble!(Kff)
+	Assemble!(Kfs)
+	Assemble!(pf)
+	
+	return Kff, Kfs, pf
+end# }}}
+function CreateNodalConstraintsx(nodes::Vector{Node})# {{{
+
+	#Allocate vector
+	ssize=NumberOfDofs(nodes,SsetEnum)
+	ys=IssmVector(ssize)
+
+	#constraints vector with the constraint values
+	for i in 1:length(nodes)
+		CreateNodalConstraints(nodes[i],ys)
+	end
+
+	return ys
+end# }}}
+function RequestedOutputsx(femmodel::FemModel,outputlist::Vector{IssmEnum})# {{{
+
+	#Get Step and Time from parameters
+	step = FindParam(femmodel.parameters,StepEnum)
+	time = FindParam(femmodel.parameters,TimeEnum)
+	
+	#Now fetch results
+	for i in 1:length(outputlist)
+
+		#See if outputlist[i] is an input
+		if outputlist[i]>InputsSTARTEnum && outputlist[i]<InputsENDEnum
+
+			#Create Result
+			input  = GetInput(femmodel.inputs,outputlist[i])
+			result = Result(outputlist[i], step, time, copy(input.values))
+
+			#Add to femmodel.results dataset
+			push!(femmodel.results, result)
+
+		else
+			println("Output ",outputlist[i]," not supported yet")
+		end
+	end
+end# }}}
+function MigrateGroundinglinex(femmodel::FemModel)# {{{
+
+	for i=1:length(femmodel.elements)
+		MigrateGroundingLine(femmodel.elements[i])
+	end
+
+end# }}}
+function UpdateConstraintsx(femmodel::FemModel, analysis::Analysis)# {{{
+
+	#First, see if the analysis needs to change constraints
+	UpdateConstraints(analysis, femmodel)
+
+	#Second, constraints might be time dependent
+	SpcNodesx(femmodel.nodes, femmodel.constraints, femmodel.parameters)
+
+	#Now, update degrees of freedoms
+	NodesDofx(femmodel.nodes, femmodel.parameters)
+
+end# }}}
+function SetActiveNodesLSMx(femmodel::FemModel) #{{{
+
+	#Check mask of each element to see if element is active
+	numnodes = 3
+	mask = Vector{Float64}(undef, numnodes)
+	for i in 1:length(femmodel.elements)
+		GetInputListOnNodes!(femmodel.elements[i], mask, IceMaskNodeActivationEnum)
+		for j in 1:numnodes
+			node = femmodel.elements[i].nodes[j]
+			if(mask[j]==1.) Activate!(node)
+			else             Deactivate!(node)
+			end
+		end
+
+	end
+end#}}}
+function GetMaskOfIceVerticesLSMx0(femmodel::FemModel) #{{{
+
+	#Initialize vector with number of vertices
+	numvertices=length(femmodel.vertices)
+   if(numvertices==0) return end
+
+	#Initialize vector
+	nbv = 3
+	onesvec      = ones(nbv)
+	vec_mask_ice = IssmVector(numvertices)
+	vertexids    = Vector{Int64}(undef, nbv)
+
+	#Assign values to vector
+	for i in 1:length(femmodel.elements)
+		if (IsIceInElement(femmodel.elements[i]))
+			for j in 1:nbv
+				vertexids[j] = femmodel.elements[i].vertices[j].sid
+			end
+			SetValues!(vec_mask_ice, nbv, vertexids, onesvec)
+		end
+	end
+	Assemble!(vec_mask_ice)
+
+	#Serialize vector
+	vec_mask_ice_serial = ToSerial(vec_mask_ice)
+
+	#Update IceMaskNodeActivationEnum in elements
+	InputUpdateFromVectorx(femmodel, vec_mask_ice_serial, IceMaskNodeActivationEnum, VertexSIdEnum)
+end#}}}
Index: issm/trunk/src/jl/core/nodes.jl
===================================================================
--- issm/trunk/src/jl/core/nodes.jl	(revision 26744)
+++ issm/trunk/src/jl/core/nodes.jl	(revision 26744)
@@ -0,0 +1,267 @@
+#Node class definition
+mutable struct Node #{{{
+	id::Int64
+	sid::Int64
+	indexingupdate::Bool
+	active::Bool
+	gsize::Int64
+	gdoflist::Vector{Int64}
+	fdoflist::Vector{Int64}
+	sdoflist::Vector{Int64}
+	svalues::Vector{Float64}
+end# }}}
+
+#Node functions
+function Base.show(io::IO, this::Node)# {{{
+
+	println(io,"Node:")
+	println(io,"   id:  ",this.id)
+	println(io,"   sid: ",this.sid)
+	println(io,"   indexingupdate: ",this.indexingupdate)
+	println(io,"   gsize: ",this.gsize)
+	println(io,"   gdoflist: ",this.gdoflist)
+	println(io,"   fdoflist: ",this.fdoflist)
+	println(io,"   sdoflist: ",this.sdoflist)
+	println(io,"   svalues: ",this.svalues)
+end# }}}
+function Activate!(node::Node) #{{{
+
+	if(!node.active)
+		node.indexingupdate = true
+		node.active = true
+		for i in 1:node.gsize
+			node.fdoflist[i]  = +1
+			node.sdoflist[i]  = -1
+			node.svalues[i]   = 0.0
+		end
+	end
+
+end# }}}
+function Deactivate!(node::Node) #{{{
+
+	if(node.active)
+		node.indexingupdate = true
+		node.active = false
+		for i in 1:node.gsize
+			node.fdoflist[i]  = -1
+			node.sdoflist[i]  = +1
+			node.svalues[i]   = 0.0
+		end
+	end
+
+end# }}}
+function ApplyConstraint(node::Node,dof::Int8,value::Float64) #{{{
+
+	node.indexingupdate = true
+	node.fdoflist[dof]  = -1
+	node.sdoflist[dof]  = +1
+	node.svalues[dof]   = value
+
+end# }}}
+function CreateNodalConstraints(node::Node,ys::IssmVector) #{{{
+
+	if(SSize(node)>0)
+		SetValues!(ys,node.gsize,node.sdoflist,node.svalues)
+	end
+
+end# }}}
+function DistributeDofs(node::Node,setenum::IssmEnum,dofcount::Int64) #{{{
+
+	if setenum==GsetEnum
+		for i in 1:node.gsize
+			node.gdoflist[i] = dofcount
+			dofcount += 1
+		end
+	elseif setenum==FsetEnum
+		for i in 1:node.gsize
+			if  node.fdoflist[i]!=-1
+				@assert node.sdoflist[i]==-1
+				node.fdoflist[i] = dofcount
+				dofcount += 1
+			end
+		end
+	elseif setenum==SsetEnum
+		for i in 1:node.gsize
+			if  node.sdoflist[i]!=-1
+				@assert node.fdoflist[i]==-1
+				node.sdoflist[i] = dofcount
+				dofcount += 1
+			end
+		end
+	else
+		error("not supported")
+	end
+
+	return dofcount
+end# }}}
+function GetNumberOfDofs(node::Node,setenum::IssmEnum) #{{{
+
+	if setenum==GsetEnum
+		dofcount = node.gsize
+	elseif setenum==FsetEnum
+		dofcount = 0
+		for i=1:node.gsize
+			if  node.fdoflist[i]!=-1
+				dofcount += 1
+			end
+		end
+	elseif setenum==SsetEnum
+		dofcount = 0
+		for i=1:node.gsize
+			if  node.sdoflist[i]!=-1
+				dofcount += 1
+			end
+		end
+	else
+		error("not supported")
+	end
+
+	return dofcount
+
+end# }}}
+function GetDofList(node::Node,doflist::Vector{Int64},count::Int64,setenum::IssmEnum) #{{{
+
+	if setenum==GsetEnum
+		for i in 1:node.gsize
+			count += 1
+			doflist[count] = node.gdoflist[i]
+		end
+	elseif setenum==FsetEnum
+		for i=1:node.gsize
+			#if  node.fdoflist[i]!=-1
+				count += 1
+				doflist[count] = node.fdoflist[i]
+			#end
+		end
+	elseif setenum==SsetEnum
+		for i=1:node.gsize
+			#if  node.sdoflist[i]!=-1
+				count += 1
+				doflist[count] = node.sdoflist[i]
+			#end
+		end
+	else
+		error("not supported")
+	end
+
+	return count
+
+end# }}}
+function GetGlobalDofList(nodes::Vector{Node},ndofs::Int64,setenum::IssmEnum) #{{{
+
+	#Allocate list
+	doflist = Vector{Int64}(undef,ndofs)
+
+	#Assign values 
+	count = 0
+	for i in 1:length(nodes)
+		count = GetDofList(nodes[i],doflist,count,setenum)
+	end
+	@assert count==ndofs
+
+	return doflist
+
+end# }}}
+function VecReduce(node::Node,ug::Vector{Float64},uf::IssmVector) #{{{
+
+	for i=1:node.gsize
+		if node.fdoflist[i]!=-1
+			uf.vector[node.fdoflist[i]] = ug[node.gdoflist[i]]
+		end
+	end
+
+end# }}}
+function VecMerge(node::Node,ug::IssmVector,uf::Vector{Float64},ys::Vector{Float64}) #{{{
+
+	fsize = FSize(node)
+	ssize = SSize(node)
+
+	if fsize>0
+		indices = Vector{Int64}(undef,fsize)
+		values  = Vector{Float64}(undef,fsize)
+
+		count = 1
+		for i=1:node.gsize
+			if node.fdoflist[i]!=-1
+				indices[count] = node.gdoflist[i]
+				values[count]  = uf[node.fdoflist[i]]
+				count += 1
+			end
+		end
+		SetValues!(ug,fsize,indices,values)
+	end
+
+	if ssize>0
+		indices = Vector{Int64}(undef,ssize)
+		values  = Vector{Float64}(undef,ssize)
+
+		count = 1
+		for i=1:node.gsize
+			if node.sdoflist[i]!=-1
+				indices[count] = node.gdoflist[i]
+				values[count]  = ys[node.sdoflist[i]]
+				count += 1
+			end
+		end
+		SetValues!(ug,ssize,indices,values)
+	end
+
+end# }}}
+function SSize(node::Node) #{{{
+
+	ssize = 0
+
+	for i=1:node.gsize
+		if node.sdoflist[i]!=-1
+			ssize+=1
+		end
+	end
+
+	return ssize
+
+end# }}}
+function FSize(node::Node) #{{{
+
+	fsize = 0
+
+	for i=1:node.gsize
+		if node.fdoflist[i]!=-1
+			fsize+=1
+		end
+	end
+
+	return fsize
+
+end# }}}
+
+#Nodes functions
+function RequiresDofReindexing(nodes::Vector{Node}) #{{{
+
+	for i in 1:length(nodes)
+		if nodes[i].indexingupdate
+			return true
+		end
+	end
+
+	return false
+
+end# }}}
+function DistributeDofs(nodes::Vector{Node},setenum::IssmEnum) #{{{
+
+	dofcount = 1
+
+	for i in 1:length(nodes)
+		dofcount = DistributeDofs(nodes[i],setenum,dofcount)
+	end
+
+
+end# }}}
+function NumberOfDofs(nodes::Vector{Node},setenum::IssmEnum) #{{{
+
+	numdofs = 0
+	for i in 1:length(nodes)
+		numdofs += GetNumberOfDofs(nodes[i],setenum)
+	end
+	return numdofs
+
+end# }}}
Index: issm/trunk/src/jl/core/parameters.jl
===================================================================
--- issm/trunk/src/jl/core/parameters.jl	(revision 26744)
+++ issm/trunk/src/jl/core/parameters.jl	(revision 26744)
@@ -0,0 +1,53 @@
+#Parameter class definition
+abstract type Parameter end
+struct DoubleParam <: Parameter #{{{
+	enum::IssmEnum
+	value::Float64
+end# }}}
+struct IntParam <: Parameter #{{{
+	enum::IssmEnum
+	value::Int64
+end# }}}
+struct BoolParam <: Parameter #{{{
+	enum::IssmEnum
+	value::Bool
+end# }}}
+
+#Parameters dataset class definition
+mutable struct Parameters #{{{
+	lookup::Dict{IssmEnum,Parameter}
+end# }}}
+
+#Parameter functions
+function GetParameterValue(param::DoubleParam) #{{{
+	return param.value
+end#}}}
+function GetParameterValue(param::IntParam) #{{{
+	return param.value
+end#}}}
+function GetParameterValue(param::BoolParam) #{{{
+	return param.value
+end#}}}
+
+#Parameters functions
+function AddParam(parameters::Parameters,value::Float64,enum::IssmEnum) #{{{
+
+	parameters.lookup[enum] = DoubleParam(enum,value)
+
+end#}}}
+function AddParam(parameters::Parameters,value::Int64, enum::IssmEnum) #{{{
+
+	parameters.lookup[enum] = IntParam(enum,value)
+
+end#}}}
+function AddParam(parameters::Parameters,value::Bool, enum::IssmEnum) #{{{
+
+	parameters.lookup[enum] = BoolParam(enum,value)
+
+end#}}}
+function FindParam(parameters::Parameters,enum::IssmEnum) #{{{
+
+	param = parameters.lookup[enum]
+	return GetParameterValue(param)
+
+end#}}}
Index: issm/trunk/src/jl/core/results.jl
===================================================================
--- issm/trunk/src/jl/core/results.jl	(revision 26744)
+++ issm/trunk/src/jl/core/results.jl	(revision 26744)
@@ -0,0 +1,6 @@
+mutable struct Result #{{{
+	enum::IssmEnum
+	step::Int64
+	time::Float64
+	value
+end#}}}
